#include "stdafx.h"
#include "MainForm.h"
#include "form.h"

using namespace System::IO;
using namespace System::Windows;

namespace Example
{

	std::string SysToStd (String ^ txt)
	{
		int len = txt->Length;
		char * p = new char [len+1];
		for (int i = 0; i < len; i ++)
			p[i] = char (txt[i]);
		p[len] = 0;
		std::string s (p);
		delete [] p;
		return s;
	}

	String ^ StdToSys (std::string s)
	{
		String ^ txt = gcnew String (s.c_str ());
		return txt;
	}

	String ^ IntToStr (int n)
	{
	   return "" + n;
	}
			
	/* Output Text */

	void MainForm::ShowOutLine (std::string txt)
	{
		txt = txt;
		outputArea->AppendText (StdToSys (txt) + "\r\n");
	}

	/* Status Bar */

    void MainForm::SetStatus (std::string txt)
	{
        statusLabel->Text = StdToSys (txt);
	}

	/* Tree */

	void MainForm::OpenBranch(std::string txt)
	{
		System::Windows::Forms::TreeNode^  node = gcnew System::Windows::Forms::TreeNode;
		node->Text = StdToSys(txt);
		if (active == nullptr)
		{
			treeView->Nodes->Add(node);
		}
		else
		{
		   active->Nodes->Add (node);
	    }
		active = node;

	}

	void MainForm::CloseBranch ()
	{
		if (active != nullptr)
			active = active->Parent;
	}

	/* Run */

	void MainForm::Run ()
	{
		run();
	}

	/* Change Font */

	void MainForm::fontMenuItem_Click(System::Object^  sender, System::EventArgs^  e)
	{
  	    fontDialog->Font = treeView->Font;
		if (fontDialog->ShowDialog () == Forms::DialogResult::OK)
		{
			treeView->Font = fontDialog->Font;
			outputArea->Font = fontDialog->Font;
		}
	}

	/* main */

	[STAThreadAttribute]
	int main(array<System::String ^> ^args)
	{
		// Enabling Windows XP visual effects before any controls are created
		Application::EnableVisualStyles();
		Application::SetCompatibleTextRenderingDefault(false);

		// Create the main window and run it
		Application::Run(gcnew MainForm());
		return 0;
	}

} // end of namespace


